#ifndef PROCESSB_H
#define PROCESSB_H

#include <dolc.h>
#include "temp_asn1.h"
#include "global.h"

//= For every input and output channel  a port and a macro-function are declared =//
#define PORT_IN1 "p_PROC_XIF_Read"

#define processbmics_RI_XIF_Read(arg_data_ptr, arg_valid_ptr) \
if (1) { \
	DOLCData dolcdat; \
	dolcdat.data = (arg_data_ptr); \
	dolcdat.size = sizeof(asn1SccMyReal); \
	DOLC_read((void*) PORT_IN1, &(dolcdat), 1, p); \
	*(arg_valid_ptr) = dolcdat.valid; \
}

//=== structure definition of the process state
typedef struct _dolc_local_states
{
  float sum;
} processbmics_State;


//Function Declarations
void processbmics_init(DOLCProcess *);
void processbmics_fire(DOLCProcess *, int);
void processbmics_terminate(DOLCProcess *);

#define MODE_NORMAL   1
#define MODE_DEGRADED 0

#endif
