/* Functions to be filled by the user (never overwritten by buildsupport tool) */
#include "processb.h"
#include "global.h"

struct processb_state_t {
  float sum;
};

static struct processb_state_t state;

void processb_startup()
{
    /* Write your initialization code here,
       but do not make any call to a required interface. */
    state.sum = 0;
}

void processb_PI_fire()
{
    /* Write your code here! */
    mark_start(3);
    asn1SccMyReal my_data;
    asn1SccT_Boolean validity;
    processb_RI_XIF_Read(&my_data, &validity);
 
    //-------------
    PROCESS_B_BODY();
    //-------------
    
    userPrintf("---------------------------------------\n");
    if (validity == true) {
      state.sum = state.sum+my_data;
      userPrintf("ProcessB read: %f    Checksum: %f\n", (float) my_data, (float) state.sum);
    } else {
       userPrintf("---------------------------------------\n");
       userPrintf("ProcessB read no data.\n");
    }
    userPrintf("---------------------------------------\n\n\n");   
    mark_end();
}



