#include <string.h>

#include "task1.h"

// initialization function
void task1_init(DOLCProcess *p) {
	p->local->index = 0;
}

// fire function
void task1_fire(DOLCProcess *p, int modeProd) {
   char buf[1001];
   const int sz = 1000;
	
   switch (modeProd) {
	case MODE_NORMAL: 
		PHASE("mode_normal");
	
	    //printf("Task 1: MODE_NORMAL fire with index %d\n", p->local->index);
        if (p->local->index%2==0) {
	        printf("Task 1 (%s): Executing for around 0.5 seconds\n", thread_info(buf,sz));       
	        fflush(stdout);
            execute_loop_for_msec( 500); 
        } else {
	        printf("Task 1 (%s): Executing for around 2.5 seconds\n", thread_info(buf,sz));       
	        fflush(stdout);
            execute_loop_for_msec( 2500); 
        }


       break;

	case MODE_DEGRADED:
		PHASE("mode_degraded");
	    printf("Task 1 (%s): ERROR! unexpected degraded mode?\n", thread_info(buf,sz));
	    fflush(stdout);
		break;
	}

	p->local->index++;

	return;
}

// terminate function
void task1_terminate(DOLCProcess *p) {
	fflush(stdout);
}
