/* Functions to be filled by the user (never overwritten by buildsupport tool) */

#include "sq.h"
#include <stdio.h>

struct sq_state_t {
  int index;
  int length;
};

static struct sq_state_t state;

void sq_startup()
{
    /* Write your initialization code here,
       but do not make any call to a required interface. */
    state.index = 0;
    state.length = 200;
}

void sq_PI_fire()
{
    /* Write your code here! */
    asn1SccMyReal x, y;
    asn1SccT_Boolean x_valid,y_valid, ywrite_fail;

   if (state.index < state.length)
   {
	sq_RI_XIF_Read(&x, &x_valid);
	if(x_valid == true)
	{
	   printf("---------------------------------------\n");
	   printf("SQ function reads %f from X generator\n", (float)x);
           y = x * x;
	   y_valid = true;
           
           sq_RI_YIF_Write(&y, &y_valid, &ywrite_fail);
	   
	
           if (ywrite_fail != true) 
           {
	       printf("---------------------------------------\n");
	       printf("SQ function wrote %f\n", (float) y); 
           } 
           else 
           {
	       printf("---------------------------------------\n");
               printf("SQ function FAILED to write %f!\n", (float) y); 
           }

	}
        else
	{
	   printf("---------------------------------------\n");
           printf("SQ function FAILED to read data from X generator\n");
	}
	 	
   }
   state.index++;


    
 //   int count = 0;
 //   int time  = 1000*state.call_counter;
 //   printf("Time: [%d] (pc)\n",time);
 /*   while (true) {
      percons_RI_mb1_read(&my_data, &validity);
      if (!validity) break;
      printf("\tConsumer read: %d\n", (int) my_data); 
      state.last_read = (int) my_data;
      count++;
    }
    //printf("Consumer read: %d  values in this round.\n", count); 
    state.call_counter++;
*/
}

