/* Functions to be filled by the user (never overwritten by buildsupport tool) */

#include "xsporadic.h"
#include <stdio.h>

struct xsporadic_state_t {
  float written_value;
};

static struct xsporadic_state_t state;

void xsporadic_startup()
{
    /* Write your initialization code here,
       but do not make any call to a required interface. */
    state.written_value = 212.212;
}

void xsporadic_PI_fire()
{
    /* Write your code here! */
    asn1SccMyReal my_data;
    my_data = 0.45 * state.written_value;
    state.written_value++;

    asn1SccT_Boolean my_valid = true;   
    asn1SccT_Boolean  my_fail; 
    
    xsporadic_RI_XIF_Write( &my_data, &my_valid, &my_fail);
    
    if (my_fail==false) {
	printf("---------------------------------------\n");
        printf("\tX Generator wrote %f\n", (float) my_data); 
    } else {
	printf("---------------------------------------\n");
        printf("\tX Generator FAILED to write %f!\n",(float) my_data );
    }
}

