/* Functions to be filled by the user (never overwritten by buildsupport tool) */

#include "xtrigger.h"
#include <stdio.h>

struct xtrigger_state_t {
  int trigger_counter;
  int proto_counter;
  int call_counter;
  int step;
};
static struct xtrigger_state_t state;

void xtrigger_startup()
{
    /* Write your initialization code here,
       but do not make any call to a required interface. */
    state.call_counter = 0;
    state.proto_counter = 0;
    state.step = 1;
    state.trigger_counter = 0;
}

void xtrigger_PI_proto_fire()
{
    /* Write your code here! */
    int time  = 80*state.proto_counter;

    if ((state.proto_counter/5) == state.call_counter) {
      if ((state.proto_counter%5) == state.trigger_counter) {
      
	if (state.trigger_counter == 4) {
	  state.step = -1;
	}
 
	if (state.trigger_counter == 0) {
	  state.step = +1;
	}
      
	state.trigger_counter += state.step;
      
	// trigger!
        printf("---------------------------------------\n");
	printf("Time: [%d] (tr)\n", time);
 	xtrigger_RI_fire();
        state.call_counter++;   
      }
    }
    state.proto_counter++; 
}

