/* Functions to be filled by the user (never overwritten by buildsupport tool) */

#include "yperiodic.h"
#include <stdio.h>

struct yperiodic_state_t {
  float sum;
};

static struct yperiodic_state_t state;

void yperiodic_startup()
{
    /* Write your initialization code here,
       but do not make any call to a required interface. */
    state.sum = 0;
}

void yperiodic_PI_fire()
{
    /* Write your code here! */
    asn1SccMyReal my_data;
    asn1SccT_Boolean validity;
    yperiodic_RI_YIF_Read(&my_data, &validity);
    
    if (validity == true) {
      state.sum = state.sum+my_data;
      printf("---------------------------------------\n");
      printf("Y periodic sink read: %f    Checksum: %f\n", (float) my_data, (float) state.sum);
    } else {
       printf("---------------------------------------\n");
       printf("Y periodic sink read no data.\n");
    }
   
}

