/* Functions to be filled by the user (never overwritten by buildsupport tool) */
#include "processbmics.h"



void processbmics_init(DOLCProcess *p)
{
    /* Write your initialization code here,
       but do not make any call to a required interface. */
    (*p->local).sum = 0;
}

void processbmics_fire(DOLCProcess *p, int modeprocessbmics)
{
    /* Write your code here! */
    mark_start(3);

    if (modeprocessbmics!=MODE_DEGRADED) { 
        asn1SccMyReal my_data;
        asn1SccT_Boolean validity;
        processbmics_RI_XIF_Read(&my_data, &validity);

        //-------------
        PROCESS_B_BODY();
        //-------------
        
        userPrintf("---------------------------------------\n");
        if (validity == true) {
          (*p->local).sum = (*p->local).sum+my_data;
          userPrintf("ProcessB read: %f    Checksum: %f\n", (float) my_data, (float) (*p->local).sum);
        } else {
           userPrintf("---------------------------------------\n");
           userPrintf("ProcessB read no data.\n");
        }
        userPrintf("---------------------------------------\n\n\n");   
    }

    mark_end();
}




// terminate function
void processbmics_terminate(DOLCProcess *p)
{
	fflush(stdout);
}
