/* Functions to be filled by the user (never overwritten by buildsupport tool) */
#include "processa.h"
#include "global.h"

struct processa_state_t {
  float sum;
};

static struct processa_state_t state;

void processa_startup()
{
    /* Write your initialization code here,
       but do not make any call to a required interface. */
    state.sum = 0;
}

void processa_PI_fire()
{
    mark_start(2);
    /* Write your code here! */
    asn1SccMyReal my_data;
    asn1SccT_Boolean validity;
    processa_RI_XIF_Read2(&my_data, &validity);

    //-----------------
    PROCESS_A_BODY();
    //------------------

    userPrintf("---------------------------------------\n");
    if (validity == true) {
      state.sum = state.sum+my_data;
      userPrintf("ProcessA read: %f    Checksum: %f\n", (float) my_data, (float) state.sum);
    } else {
       userPrintf("---------------------------------------\n");
       userPrintf("ProcessA read no data.\n");
    }
    userPrintf("---------------------------------------\n\n\n");   
    mark_end();
}



