/* Functions to be filled by the user (never overwritten by buildsupport tool) */

#include "xmailbox.h"
#define MB_LENGTH 8

typedef asn1SccMyReal MB_TYPE;

struct xmailbox_contents_t {
  MB_TYPE buff_data[MB_LENGTH];
  int rpos, wpos, tokens;
};

static struct xmailbox_contents_t  mb_contents;

void xmailbox_startup()
{
    /* Write your initialization code here,
       but do not make any call to a required interface. */
    mb_contents.rpos   = 0;
    mb_contents.wpos   = 0;
    mb_contents.tokens = 0;
}

void xmailbox_PI_XIF_Write(const asn1SccMyReal *IN_write_data, const asn1SccT_Boolean *IN_valid, asn1SccT_Boolean *OUT_write_fail)
{
    /* Write your code here! */
    /*assumption of TASTE*/
    int len = 1; 
    /* Write your code here! */
    struct xmailbox_contents_t* p = &mb_contents;
    if (*IN_valid) {
        int elements_to_write = len;
	*OUT_write_fail = false;
        if (p->tokens + elements_to_write > MB_LENGTH) {
	  *OUT_write_fail =  true;//too many: (p->tokens + elements_to_write) - MB1_LENGTH;
	  elements_to_write = elements_to_write - *OUT_write_fail;
	}
	
	int k;
	for ( k=0; k < elements_to_write; k++, p->wpos=(p->wpos+1)%MB_LENGTH) {
	    p->buff_data[p->wpos] = IN_write_data[k]; 
	    //printf("DEBUG %d\n", (int)IN_write_data[k]); 
	}
	p->tokens = p->tokens + elements_to_write;
	
    } else {
      // writing invalid data=>erasing
      int elements_to_erase = len;
      *OUT_write_fail = 0;
      if (elements_to_erase > p->tokens) {
	*OUT_write_fail =  true;//too many: elements_to_erase - p->tokens;
	elements_to_erase = p->tokens;;	
      }
      p->tokens = p->tokens - elements_to_erase;
      p->wpos = ((p->wpos + MB_LENGTH) - elements_to_erase) % MB_LENGTH;
   }
}

void xmailbox_PI_XIF_Read(asn1SccMyReal *OUT_read_data, asn1SccT_Boolean *OUT_valid)
{
    /* Write your code here! */
    int len = 1; 
    
    /* Write your code here! */
    struct xmailbox_contents_t* p = &mb_contents;
    if (p->tokens < len) {
      *OUT_valid = false;
    } else {
      *OUT_valid = true;
      int k;
      for ( k=0; k < len; k++, p->rpos=(p->rpos+1)%MB_LENGTH) {
	 OUT_read_data[k] = p->buff_data[p->rpos]; 
      }
      p->tokens = p->tokens - len;
    } 
}

